Attribute VB_Name = "Functions"
Option Explicit

Public Function IP_2_String(IP As IP_Type) As String
IP_2_String = Trim(Str(IP.IP(0))) & "." & Trim(Str(IP.IP(1))) & "." & Trim(Str(IP.IP(2))) & "." & Trim(Str(IP.IP(3)))
End Function

Public Function String_2_IP(IP_String As String) As IP_Type
Dim Tmp_ar() As String
Dim Tmp_loop As Long
Tmp_ar = Split(IP_String, ".", 4, vbTextCompare)
ReDim Preserve Tmp_ar(3) 'To prevent errors ensure 4 elements in array..
For Tmp_loop = 0 To 3
    String_2_IP.IP(Tmp_loop) = Val(Tmp_ar(Tmp_loop)) And &HFF ' Ensure valid numbers (0-255)
Next Tmp_loop
End Function

Public Function IP_2_Long(IP As IP_Type) As Long
If IP.IP(0) < 128 Then
    IP_2_Long = IP.IP(3) Or (IP.IP(2) * CLng(&H100)) Or (IP.IP(1) * &H10000) Or (IP.IP(0) * &H1000000)
Else
    IP_2_Long = IP.IP(3) Or (IP.IP(2) * CLng(&H100)) Or (IP.IP(1) * &H10000) Or ((IP.IP(0) And &H7F) * &H1000000)
    IP_2_Long = IP_2_Long - 2147483647 - 1
End If
End Function

Public Function Long_2_IP(IP_Long As Long) As IP_Type
Long_2_IP.IP(3) = IP_Long And &HFF
Long_2_IP.IP(2) = (IP_Long And &H1FF00) / &H100 And &HFF
Long_2_IP.IP(1) = (IP_Long And &HFF0000) / &H10000

Long_2_IP.IP(0) = (IP_Long And &H7F000000) / &H1000000
If IP_Long < 0 Then Long_2_IP.IP(0) = Long_2_IP.IP(0) + 128
End Function

Public Sub Parse_SN_M(SN_Mask As IP_Type, L_IP As IP_Type)
Dim Tmp_Loop_1 As Long
Dim Tmp_Loop_2 As Long
Dim InvSN(3) As Byte
Dim IP_M(3) As Byte
For Tmp_Loop_1 = 0 To 3
    InvSN(Tmp_Loop_1) = Not (SN_Mask.IP(Tmp_Loop_1))
    IP_M(Tmp_Loop_1) = InvSN(Tmp_Loop_1) Or L_IP.IP(Tmp_Loop_1)
    SN_T(Tmp_Loop_1) = -1
Next Tmp_Loop_1
For Tmp_Loop_2 = 0 To 254
    For Tmp_Loop_1 = 0 To 3
        If (Tmp_Loop_2 Or InvSN(Tmp_Loop_1)) = IP_M(Tmp_Loop_1) Then
            SN_T(Tmp_Loop_1) = SN_T(Tmp_Loop_1) + 1
            SN_M(Tmp_Loop_1, SN_T(Tmp_Loop_1)) = Tmp_Loop_2
        End If
    Next Tmp_Loop_1
Next Tmp_Loop_2
End Sub

Public Function Add_User(Details As String, Optional Remote As Boolean, Optional Remote_IP As String) As Users_Type
Dim Tmp_ar() As String
Dim Tmp_loop As Long

Tmp_ar = Split(Details, ":", 5, vbTextCompare)
Add_User.IP = String_2_IP(Tmp_ar(2)) 'Return user details..
Add_User.Name = Tmp_ar(1)
Add_User.Hidden = (Tmp_ar(3) = "1")
Add_User.Color = CLng(Tmp_ar(4))
If Remote Then
    Add_User.Remote = True
    Add_User.Remote_Server_IP = String_2_IP(Remote_IP)
Else
    Add_User.Remote = False
    Add_User.Remote_Server_IP = String_2_IP("0.0.0.0")
End If
For Tmp_loop = 0 To UBound(Users)
    If Tmp_ar(2) = IP_2_String(Users(Tmp_loop).IP) Then  ' If user ip on list update Name and Exit.
        Users(Tmp_loop).Name = Add_User.Name
        If Users(Tmp_loop).Hidden <> Add_User.Hidden Then
            If Add_User.Hidden Then
                H_Users = H_Users + 1
            Else
                H_Users = H_Users - 1
            End If
            Users(Tmp_loop).Hidden = Add_User.Hidden
            If H_Users > 0 Then
                Main_f.Hid_users.Caption = H_Users & " Hidden"
            Else
                Main_f.Hid_users.Caption = ""
            End If
        End If
        Users(Tmp_loop).Online = True
        Users(Tmp_loop).Color = Add_User.Color
        Users(Tmp_loop).Remote = Add_User.Remote
        Users(Tmp_loop).Remote_Server_IP = Add_User.Remote_Server_IP
        Exit Function
    End If
Next Tmp_loop
'user not on list -- Add new..
ReDim Preserve Users(UBound(Users) + 1)
Users(UBound(Users)).Color = Add_User.Color
Users(UBound(Users)).IP = Add_User.IP
Users(UBound(Users)).Name = Add_User.Name
Users(UBound(Users)).Hidden = Add_User.Hidden
Users(UBound(Users)).Online = True
Users(UBound(Users)).Remote = Add_User.Remote
Users(UBound(Users)).Remote_Server_IP = Add_User.Remote_Server_IP
End Function

Public Function Del_User(Details As String) As Users_Type
Dim Tmp_ar() As String
Dim Tmp_loop As Long
Dim Tmp_Loop_2 As Long
Dim Tmp_user As String
Dim Tmp_Ip As IP_Type

Tmp_ar = Split(Details, ":", 4, vbTextCompare)
Del_User.IP = String_2_IP(Tmp_ar(2)) 'Return user details..
Del_User.Name = Tmp_ar(1)
For Tmp_loop = 0 To UBound(Users)
    If Tmp_ar(2) = IP_2_String(Users(Tmp_loop).IP) Then  ' If user ip on list remove and shift others down...
        For Tmp_Loop_2 = Tmp_loop To UBound(Users) - 1
            Users(Tmp_Loop_2) = Users(Tmp_Loop_2 + 1)
        Next Tmp_Loop_2
        ReDim Preserve Users(UBound(Users) - 1)
        Exit Function
    End If
Next Tmp_loop
'user not on list -- Ignore..
End Function

Public Function StripName(inname As String) As String
Dim Tmp_loop
For Tmp_loop = Len(inname) To 1 Step -1
    If (Mid$(inname, Tmp_loop, 1)) = "\" Or (Mid$(inname, Tmp_loop, 1)) = "/" Then
        StripName = Right$(inname, Len(inname) - Tmp_loop)
        Exit Function
    End If
Next Tmp_loop
End Function

Public Function StripLoc(inname As String) As String
Dim Tmp_loop
For Tmp_loop = Len(inname) To 1 Step -1
    If (Mid$(inname, Tmp_loop, 1)) = "\" Or (Mid$(inname, Tmp_loop, 1)) = "/" Then
        StripLoc = Left$(inname, Tmp_loop)
        Exit Function
    End If
Next Tmp_loop
End Function

Public Function Bool_2_String(Bool As Boolean) As String
If Bool Then
    Bool_2_String = "1"
Else
    Bool_2_String = "0"
End If
End Function

Public Sub Get_Reg_Keys()
User = GetSetting("IPLINK", "IPsetting", "user", User)
L_Port = GetSetting("IPLINK", "IPsetting", "port", "1699")
Subnet = String_2_IP(GetSetting("IPLINK", "IPsetting", "subnet", "255.255.255.0"))
Colour = GetSetting("IPLINK", "IPsetting", "Color", &H101010)
End Sub

Public Sub Save_Reg_Keys()
SaveSetting "IPLINK", "IPsetting", "user", Users(0).Name
SaveSetting "IPLINK", "IPsetting", "port", L_Port
SaveSetting "IPLINK", "IPsetting", "subnet", IP_2_String(Subnet)
SaveSetting "IPLINK", "IPsetting", "Color", Users(0).Color
End Sub


    

